package hk.edu.hkbu.comp.maw2013.mybbc;

import com.example.mybbc.R;

import android.os.Bundle;
import android.support.v4.app.ActionBarDrawerToggle;
import android.support.v4.app.FragmentActivity;
import android.support.v4.app.FragmentManager;
import android.support.v4.widget.DrawerLayout;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;

public class MainActivity extends FragmentActivity {
	
	private DrawerLayout drawerLayout;
	private ListView drawerList;
    private String[] navTitles;
	private ActionBarDrawerToggle drawerToggle;
	
    /* The click listner for ListView in the navigation drawer */
    private class DrawerItemClickListener implements ListView.OnItemClickListener {
    	private int prvPosition = -1;
    	
        @Override
        public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        	if(prvPosition!=position){
        		FragmentManager fragmentManager = getSupportFragmentManager();
	        	if(position==0){
	        		fragmentManager.beginTransaction().replace(R.id.content_frame, new AsiaNewsFragment()).commit();
	        	}else{
	        		fragmentManager.beginTransaction().replace(R.id.content_frame, new FoodFragment()).commit();
	        	}
	        	
	            // update selected item and title, then close the drawer
	        	drawerList.setItemChecked(position, true);
	            setTitle(navTitles[position]);
        	}
        	drawerLayout.closeDrawer(drawerList);
            prvPosition = position;
        }
    }  
    
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		getActionBar().setDisplayHomeAsUpEnabled(true);
		
		navTitles = getResources().getStringArray(R.array.navigation_target);
        drawerLayout = (DrawerLayout) findViewById(R.id.drawer_layout);
        drawerList = (ListView) findViewById(R.id.left_drawer);
        drawerList.setAdapter(new ArrayAdapter<String>(this, R.layout.drawer_list_item, navTitles));
        drawerList.setOnItemClickListener(new DrawerItemClickListener());
        
        drawerToggle = new ActionBarDrawerToggle(
                this,                  /* host Activity */
                drawerLayout,         /* DrawerLayout object */
                R.drawable.ic_drawer,  /* nav drawer image to replace 'Up' caret */
                R.string.drawer_open,  /* "open drawer" description for accessibility */
                R.string.drawer_close  /* "close drawer" description for accessibility */
                ) {
        	
            public void onDrawerClosed(View view) {
                invalidateOptionsMenu(); // creates call to onPrepareOptionsMenu()
            }
            
            public void onDrawerOpened(View drawerView) {
                invalidateOptionsMenu(); // creates call to onPrepareOptionsMenu()
            }
        };
        drawerLayout.setDrawerListener(drawerToggle);
        
        if (savedInstanceState == null) {
        	FragmentManager fragmentManager = getSupportFragmentManager();
            fragmentManager.beginTransaction().replace(R.id.content_frame, new AsiaNewsFragment()).commit();
            drawerList.setItemChecked(0, true);
            setTitle(navTitles[0]);
            drawerLayout.closeDrawer(drawerList);
        }
	}
	
	@Override
    protected void onPostCreate(Bundle savedInstanceState) {
        super.onPostCreate(savedInstanceState);
        // Sync the toggle state after onRestoreInstanceState has occurred.
        drawerToggle.syncState();
    }
}